# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetBudgetPoliciesResult',
    'AwaitableGetBudgetPoliciesResult',
    'get_budget_policies',
    'get_budget_policies_output',
]

@pulumi.output_type
class GetBudgetPoliciesResult:
    """
    A collection of values returned by getBudgetPolicies.
    """
    def __init__(__self__, id=None, policies=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if policies and not isinstance(policies, list):
            raise TypeError("Expected argument 'policies' to be a list")
        pulumi.set(__self__, "policies", policies)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def policies(self) -> Sequence['outputs.GetBudgetPoliciesPolicyResult']:
        return pulumi.get(self, "policies")


class AwaitableGetBudgetPoliciesResult(GetBudgetPoliciesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBudgetPoliciesResult(
            id=self.id,
            policies=self.policies)


def get_budget_policies(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBudgetPoliciesResult:
    """
    This data source can be used to fetch the list of budget policies.

    > **Note** This data source can only be used with an account-level provider!

    ## Example Usage

    Getting a list of all budget policies:

    ```python
    import pulumi
    import pulumi_databricks as databricks

    all = databricks.get_budget_policies()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('databricks:index/getBudgetPolicies:getBudgetPolicies', __args__, opts=opts, typ=GetBudgetPoliciesResult).value

    return AwaitableGetBudgetPoliciesResult(
        id=pulumi.get(__ret__, 'id'),
        policies=pulumi.get(__ret__, 'policies'))
def get_budget_policies_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetBudgetPoliciesResult]:
    """
    This data source can be used to fetch the list of budget policies.

    > **Note** This data source can only be used with an account-level provider!

    ## Example Usage

    Getting a list of all budget policies:

    ```python
    import pulumi
    import pulumi_databricks as databricks

    all = databricks.get_budget_policies()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('databricks:index/getBudgetPolicies:getBudgetPolicies', __args__, opts=opts, typ=GetBudgetPoliciesResult)
    return __ret__.apply(lambda __response__: GetBudgetPoliciesResult(
        id=pulumi.get(__response__, 'id'),
        policies=pulumi.get(__response__, 'policies')))
