# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetDatabaseInstancesResult',
    'AwaitableGetDatabaseInstancesResult',
    'get_database_instances',
    'get_database_instances_output',
]

@pulumi.output_type
class GetDatabaseInstancesResult:
    """
    A collection of values returned by getDatabaseInstances.
    """
    def __init__(__self__, database_instances=None, id=None):
        if database_instances and not isinstance(database_instances, list):
            raise TypeError("Expected argument 'database_instances' to be a list")
        pulumi.set(__self__, "database_instances", database_instances)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="databaseInstances")
    def database_instances(self) -> Sequence['outputs.GetDatabaseInstancesDatabaseInstanceResult']:
        return pulumi.get(self, "database_instances")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetDatabaseInstancesResult(GetDatabaseInstancesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseInstancesResult(
            database_instances=self.database_instances,
            id=self.id)


def get_database_instances(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabaseInstancesResult:
    """
    This data source can be used to fetch the list of Database Instances within the workspace.
    The list can then be accessed via the data object's `database_instances` field.

    ## Example Usage

    Getting a list of all Database Instances:

    ```python
    import pulumi
    import pulumi_databricks as databricks

    all = databricks.get_database_instances()
    pulumi.export("allDatabaseInstances", all.database_instances)
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('databricks:index/getDatabaseInstances:getDatabaseInstances', __args__, opts=opts, typ=GetDatabaseInstancesResult).value

    return AwaitableGetDatabaseInstancesResult(
        database_instances=pulumi.get(__ret__, 'database_instances'),
        id=pulumi.get(__ret__, 'id'))
def get_database_instances_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDatabaseInstancesResult]:
    """
    This data source can be used to fetch the list of Database Instances within the workspace.
    The list can then be accessed via the data object's `database_instances` field.

    ## Example Usage

    Getting a list of all Database Instances:

    ```python
    import pulumi
    import pulumi_databricks as databricks

    all = databricks.get_database_instances()
    pulumi.export("allDatabaseInstances", all.database_instances)
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('databricks:index/getDatabaseInstances:getDatabaseInstances', __args__, opts=opts, typ=GetDatabaseInstancesResult)
    return __ret__.apply(lambda __response__: GetDatabaseInstancesResult(
        database_instances=pulumi.get(__response__, 'database_instances'),
        id=pulumi.get(__response__, 'id')))
